#NoTrayIcon
#AutoIt3Wrapper_icon=babybidou.ico

#include <GUIConstantsEx.au3>
#include <ButtonConstants.au3>
#include <GUIListBox.au3>
#Include <Array.au3>
#include <StaticConstants.au3>
#include <WindowsConstants.au3>
#include <EditConstants.au3>
#Include <GuiSlider.au3>
#include <SliderConstants.au3>
#include <EditConstants.au3>
#Include <File.au3>
#include <Constants.au3>
#include <ComboConstants.au3>

$nom="Wbidou 1.1a - Aide au transfert sur BabyBidou - CopyLeft Nicolas Ricquemaque 2008 [CeCILL2]"
Dim $bidou,$duree,$fichierfilm,$transfert,$volumemax,$volumeini,$fade,$fadeduree,$aleat,$repet,$egaliseur
Dim $reveil,$volumereveil,$sensreveil,$reveilduree,$record,$records,$noconn,$liste,$effacer,$etat,$progress
Dim $etatfilm,$progressfilm,$win,$ejection,$film,$compil,$dureesupp,$dureechap,$extraire,$liste,$cdroms
Dim $selcd,$statuscd,$compilcd,$extrairecd,$etatcd,$progresscd,$pistescd,$tab

$Apropos= "Ce logiciel a t ralis pour faciliter le transfert de compilations audio," & @CRLF
$Apropos&="le paramtrage, l'extraction audio  partir d'un film (divx, mpg, mkv...) ou " & @CRLF
$Apropos&="d'un CD sur audio un BabyBidou (http://www.babybidou.com)" & @CRLF & @CRLF
$Apropos&="Mode d'emploi: copier wbidou.exe dans un dossier contenant autant de sous-dossiers" & @CRLF
$Apropos&="que de compilations; chaque sous-dossier contiendra ses propres fichiers audio." & @CRLF & @CRLF
$Apropos&="Logiciel ralise avec AutoIt3 (http://www.autoitscript.com/autoit3/) v" & @AutoItVersion & @CRLF
$Apropos&="Utilise FFmpeg2Theora (http://v2v.cc/~j/ffmpeg2theora/) et CDRtools (http://cdrecord.berlios.de/)"& @CRLF& @CRLF
$Apropos&="Copyleft CeCILL2 - Nicolas Ricquemaque 2008 - http://opensource.grisambre.net/wbidou/"

SetupEject()

$inst=RegRead("HKEY_LOCAL_MACHINE\SOFTWARE\Wbidou","Install")
If (@error=1) Then
	If Not Licence() Then exit
	RegWrite("HKEY_LOCAL_MACHINE\SOFTWARE\Wbidou")
	RegWrite("HKEY_LOCAL_MACHINE\SOFTWARE\Wbidou","Install","REG_SZ",@ScriptFullPath)
Else
If $inst<>@ScriptFullPath Then RegWrite("HKEY_LOCAL_MACHINE\SOFTWARE\Wbidou","Install","REG_SZ",@ScriptFullPath)
EndIf

If $CmdLine[0]>0 AND $CmdLine[1]="/attendre" Then
	$status=0
	While 1
		If NOT $status Then
			If Bidou() Then
				$status=1
				$plist=ProcessList(@ScriptName)
				If $plist[0][0]<2 Then
					GUI()
					If Not RegRead("HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows\CurrentVersion\Run","Wbidou") Then exit
				EndIf
			EndIf
		EndIf
		If $status AND NOT Bidou() Then $status=0
		Sleep(1000)
	Wend
Else
	$plist=ProcessList(@ScriptName)
	If $plist[0][0]>2 Then exit
	GUI()
	exit
EndIf


Func GUI()
	$win=GUICreate($nom, 400, 250)
	If (Not @compiled) Then GUISetIcon("babybidou.ico")

	$noconn=GuiCtrlCreateLabel("Dconnect", 330, 7,default,15)
	GUICtrlSetTip(-1,"Pour effectuer des transferts ou un rglage, votre BabyBidou doit tre connect !")
	GUICtrlSetColor ( -1, 0xff0000)
	GUICtrlSetState ( -1, $GUI_HIDE )

	$tab=GuiCtrlCreateTab(5, 5, 390, 240)
	; ------------------------------------------------------------------------------- 
	$transfert=GuiCtrlCreateTabItem("Transfert")

	$liste = GUICtrlCreateList("", 20, 40, 260, 190,BitOr($GUI_SS_DEFAULT_LIST, $LBS_EXTENDEDSEL))
	GUICtrlSetTip(-1,"Slectionner la ou les compilation(s)  transfrer (pour plusieurs: Ctrl+Clic ou Maj+clic)")

	$transfert=GuiCtrlCreateButton("Go", 320, 45,40,40, $BS_ICON)
	If (@compiled) Then
		GUICtrlSetImage(-1, @ScriptFullPath,1)
	Else
		GUICtrlSetImage(-1,"babybidou.ico")
	EndIf
	GUICtrlSetTip(-1,"Transfrer vers le BabyBidou !")

	$effacer=GUICtrlCreateCheckbox ( "Vider d'abord", 300, 100)
	GuiCtrlSetState(-1,$GUI_CHECKED)
	GUICtrlSetTip(-1,"Si coch, effacera d'abord le contenu actuel avant le transfert de la nouvelle slection")

	$ejection=GUICtrlCreateCheckbox ( "Dconnexion", 300, 120)
	GuiCtrlSetState(-1,$GUI_CHECKED)
	GUICtrlSetTip(-1,"Si coch, dconnectera automatiquement le Baby Bidou  la fin du transfert")

	$etat=GuiCtrlCreateLabel("0 %", 300, 170,90,20)
	GUICtrlSetStyle(-1,$SS_CENTER)
	GUICtrlSetState(-1,$GUI_HIDE)
	$progress=GUICtrlCreateProgress(300,200,90,20,1)
	GUICtrlSetState(-1,$GUI_HIDE)
	; -------------------------------------------------------------------------------
	$configtab=GuiCtrlCreateTabItem("Rglages")

	GuiCtrlCreateLabel("Volume initial", 15, 53,80,20)
	$volumeini = GUICtrlCreateSlider(80, 50, 100, 30, BitOR($GUI_SS_DEFAULT_SLIDER, $TBS_TOOLTIPS, $TBS_AUTOTICKS))
	_GUICtrlSlider_SetTicFreq(-1,1)
	GUICtrlSetLimit(-1, 10, 0)
	GuiCtrlCreateLabel("Volume Maximal", 210, 53,80,20)
	$volumemax = GUICtrlCreateSlider(290, 50, 100, 30, BitOR($GUI_SS_DEFAULT_SLIDER, $TBS_TOOLTIPS, $TBS_AUTOTICKS))
	_GUICtrlSlider_SetTicFreq(-1,1)
	GUICtrlSetLimit(-1, 10, 0)

	$fade=GUICtrlCreateCheckbox ( 'Bouton "Fade"', 15, 90)
	GuiCtrlCreateLabel("Minutes pour chaque pression :", 150, 93)
	$fadeduree=GuiCtrlCreateInput("", 330, 90, 40,default,BitOR($GUI_SS_DEFAULT_INPUT , $ES_NUMBER))

	$aleat=GUICtrlCreateCheckbox ( 'Lecture Alatoire', 15, 120)
	$repet=GUICtrlCreateCheckbox ( 'Jouer en boucle', 140, 120)
	$egaliseur=GUICtrlCreateCheckbox ( 'Egaliseur Audio', 270, 120)

	$reveil=GUICtrlCreateCheckbox ( 'Rveil', 15, 150)
	GuiCtrlCreateLabel("Vol", 80, 153)
	$volumereveil= GUICtrlCreateSlider(95, 150, 80, 30, BitOR($GUI_SS_DEFAULT_SLIDER, $TBS_TOOLTIPS, $TBS_AUTOTICKS))
	_GUICtrlSlider_SetTicFreq(-1,1)
	GUICtrlSetLimit(-1, 10, 0)
	GuiCtrlCreateLabel("Sensibilit", 180, 153)
	$sensreveil= GUICtrlCreateSlider(230, 150, 80, 30, BitOR($GUI_SS_DEFAULT_SLIDER, $TBS_TOOLTIPS, $TBS_AUTOTICKS))
	_GUICtrlSlider_SetTicFreq(-1,1)
	GUICtrlSetLimit(-1, 10, 0)
	GuiCtrlCreateLabel("/", 310, 153)
	$reveilduree=GuiCtrlCreateInput("", 330, 150, 40,default,BitOR($GUI_SS_DEFAULT_INPUT , $ES_NUMBER))
	GuiCtrlCreateLabel("s.", 375, 153)

	$record=GUICtrlCreateCheckbox ( 'Autoriser Enregistrement', 15, 180)
	$records=GUICtrlCreateCheckbox ( 'Sonnette Enregistrement', 200, 180)

	$lancerauto=GUICtrlCreateCheckbox ( 'Dmarrer automatiquement ce logiciel lors de la connexion du BabyBidou', 15, 210)
	If StringInStr(RegRead("HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows\CurrentVersion\Run","Wbidou"),@ScriptFullPath) Then GUICtrlSetState(-1,$GUI_CHECKED)

	; -------------------------------------------------------------------------------
	GuiCtrlCreateTabItem("Extraction Film")

	$msgext ="Cet outil permet d'extraire la bande son d'un film ou dessin anim" & @CRLF
	$msgext&="(format divx, AVI, MPEG, MKV, etc) et de le couper en un ou plusieurs" & @CRLF
	$msgext&="morceaux (chapitres) pour transfrer ensuite dans le Baby Bidou." & @CRLF
	GuiCtrlCreateLabel($msgext, 20, 50, 350)

	$choixfilm=GuiCtrlCreateButton("Choisir le film >> ", 280, 110, 100)
	$film=GuiCtrlCreateInput("", 30, 110, 220,default,BitOR($GUI_SS_DEFAULT_INPUT , $ES_READONLY))

	GuiCtrlCreateLabel("Nom de la compilation", 30, 153)
	$compil=GuiCtrlCreateInput("", 140, 150, 110)
	GUICtrlSetTip(-1,"(telle qu'elle apparatra dans le liste de transfert)")
	GUICtrlSetState(-1,$GUI_DISABLE)

	GuiCtrlCreateLabel("Supprimer les", 30, 183)
	$dureesupp=GuiCtrlCreateInput("", 110, 180, 40,default,BitOR($GUI_SS_DEFAULT_INPUT , $ES_NUMBER))
	GUICtrlSetTip(-1,"Pour ventuellement supprimer le gnrique de dbut. Laisser vide pour ne rien supprimer...")
	GUICtrlSetState(-1,$GUI_DISABLE)
	GuiCtrlCreateLabel("premires secondes", 160, 183)

	GuiCtrlCreateLabel("Dure chapitres", 30, 213)
	$dureechap=GuiCtrlCreateInput("", 110, 210, 40,default,BitOR($GUI_SS_DEFAULT_INPUT , $ES_NUMBER))
	GUICtrlSetTip(-1,"Laisser vide pour etraire en un seul morceau...")
	GUICtrlSetState(-1,$GUI_DISABLE)
	GuiCtrlCreateLabel("Min.", 160, 213)

	$extraire=GuiCtrlCreateButton("Extraire !", 280, 210,100)
	GUICtrlSetState(-1,$GUI_DISABLE)

	$etatfilm=GuiCtrlCreateLabel("0 %", 280, 150,100,20)
	GUICtrlSetStyle(-1,$SS_CENTER)
	GUICtrlSetState(-1,$GUI_HIDE)
	$progressfilm=GUICtrlCreateProgress(280,170,100,20,1)
	GUICtrlSetState(-1,$GUI_HIDE)
	; -------------------------------------------------------------------------------
	$cdtab=GuiCtrlCreateTabItem("Extraction CD")
	
	$msgext ="Cet outil permet d'extraire toutes les pistes d'un CD audio vers une" & @CRLF
	$msgext&="compilation au format OGG pour ensuite transfrer sur le BabyBidou."
	GuiCtrlCreateLabel($msgext, 20, 50, 350)
	
	GuiCtrlCreateLabel("Lecteur de CD", 30, 103)
	$selcd=GUICtrlCreateCombo("",140,100,200,default,BitOr($GUI_SS_DEFAULT_COMBO, $CBS_DROPDOWNLIST))
	$statuscd=GuiCtrlCreateLabel("", 140, 133,200,20)
	
	GuiCtrlCreateLabel("Nom de la compilation", 30, 163)
	$compilcd=GuiCtrlCreateInput("", 140, 160, 110)
	GUICtrlSetTip(-1,"(telle qu'elle apparatra dans le liste de transfert)")
	GUICtrlSetState(-1,$GUI_DISABLE)
	
	GuiCtrlCreateLabel("(en cas d'insertion/retrait de CD, attendre environ 30 secondes pour que l'affichage se mette  jour...)", 20, 203,250,50)
	$extrairecd=GuiCtrlCreateButton("Extraire !", 280, 210,100)
	GUICtrlSetState(-1,$GUI_DISABLE)

	$etatcd=GuiCtrlCreateLabel("0 %", 280, 155,100,20)
	GUICtrlSetStyle(-1,$SS_CENTER)
	GUICtrlSetState(-1,$GUI_HIDE)
	$progresscd=GUICtrlCreateProgress(280,175,100,20,1)
	GUICtrlSetState(-1,$GUI_HIDE)
	
	; -------------------------------------------------------------------------------
	GuiCtrlCreateTabItem("    ?")
	GUISetFont ("7" , 400)
	GuiCtrlCreateLabel($Apropos, 20, 40,360,160)
	GUISetFont ("8.5" , 400)
	$licence=GuiCtrlCreateButton("Licence", 30, 210,70)
	$sitewbidou=GuiCtrlCreateButton("Site Wbidou", 120, 210,70)
	$sitebidou=GuiCtrlCreateButton("BabyBidou", 210, 210,70)
	$codesrc=GuiCtrlCreateButton("Code Source", 300, 210,70)
	
	; -------------------------------------------------------------------------------
	GuiCtrlCreateTabItem("")

	GUICtrlSetState($transfert,$GUI_SHOW)


	If (TestBiDou()) Then GetConfig()
	GUISetState()

	
	$search = FileFindFirstFile(@ScriptDir&"\*.*")  
	; Check if the search was successful
	If $search Then
		While 1
			$file = FileFindNextFile($search) 
			If @error Then ExitLoop
			If StringInStr(FileGetAttrib(@ScriptDir&"\"&$file),"D") AND ( FileExists(@ScriptDir&"\"&$file&"\*.mp3") OR FileExists(@ScriptDir&"\"&$file&"\*.ogg") OR FileExists(@ScriptDir&"\"&$file&"\*.oga")OR FileExists(@ScriptDir&"\"&$file&"\*.wma") OR FileExists(@ScriptDir&"\"&$file&"\*.wav") OR FileExists(@ScriptDir&"\"&$file&"\*.aac")) Then
				GUICtrlSetData ($liste,$file)
			EndIf
		WEnd

		; Close the search handle
		FileClose($search)
	EndIf


	$timercd=0
	While 1
		$bidou=TestBiDou()
		$msg = GUIGetMsg()
		
		If $msg = $transfert Then Transferer ()	
		
		If $msg = $licence Then Licence()
		If $msg = $codesrc Then
			$dest=FileSaveDialog ( "Enregistrement du code source", @ScriptDir, "Archive compresse (*.zip)", 18 , "wbidou-src.zip")
			If ($dest) Then FileInstall("wbidou-src.zip",$dest,1)
		EndIf	
		If $msg = $sitewbidou Then ShellExecute("http://opensource.grisambre.net/wbidou")
		If $msg = $sitebidou Then ShellExecute("http://www.babybidou.com")
		
		If $msg = $volumemax Then IniWrite ($bidou&"\baby_config.txt", "Speaker", "MaxSpeakerPower",GUICtrlRead($volumemax))
		If $msg = $volumeini Then IniWrite ($bidou&"\baby_config.txt", "Speaker", "InitSpeakerPower",GUICtrlRead($volumeini))
		If $msg = $fade Then IniWrite ($bidou&"\baby_config.txt", "Fading", "FadeEnable", Test(GUICtrlRead($fade)=$GUI_CHECKED,"yes","no"))
		If $msg = $fadeduree Then IniWrite ($bidou&"\baby_config.txt", "Fading", "FadingDuration",GUICtrlRead($fadeduree))
		If $msg = $aleat Then IniWrite ($bidou&"\baby_config.txt", "Random", "Random", Test(GUICtrlRead($aleat)=$GUI_CHECKED,"yes","no"))
		If $msg = $repet Then IniWrite ($bidou&"\baby_config.txt", "Repeat", "Repeat", Test(GUICtrlRead($repet)=$GUI_CHECKED,"yes","no"))
		If $msg = $egaliseur Then IniWrite ($bidou&"\baby_config.txt", "Audio", "AudioEffect", Test(GUICtrlRead($egaliseur)=$GUI_CHECKED,"yes","no"))
		If $msg = $reveil Then IniWrite ($bidou&"\baby_config.txt", "Wakeup", "VoiceAutoDetect", Test(GUICtrlRead($reveil)=$GUI_CHECKED,"yes","no"))
		If $msg = $volumereveil Then IniWrite ($bidou&"\baby_config.txt", "Wakeup", "WakeupSpeakerPower",GUICtrlRead($volumereveil))
		If $msg = $sensreveil Then IniWrite ($bidou&"\baby_config.txt", "Wakeup", "VoiceLevel",GUICtrlRead($sensreveil))
		If $msg = $reveilduree Then IniWrite ($bidou&"\baby_config.txt", "Wakeup", "VoiceDuration",GUICtrlRead($reveilduree))
		If $msg = $record Then IniWrite ($bidou&"\baby_config.txt", "Record", "RecordEnable", Test(GUICtrlRead($record)=$GUI_CHECKED,"yes","no"))
		If $msg = $records Then IniWrite ($bidou&"\baby_config.txt", "Record", "RecordWarning", Test(GUICtrlRead($records)=$GUI_CHECKED,"yes","no"))
		If $msg = $lancerauto AND @compiled Then
			If GUICtrlRead($lancerauto)=$GUI_CHECKED Then
				RegWrite("HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows\CurrentVersion\Run","Wbidou","REG_SZ",'"'&@ScriptFullPath&'" /attendre')
				MsgBox(64,"Attention","Le lancement automatique de ce logiciel  la connexion du BabyBidou" & @CRLF & "ne sera effectif qu'aprs le prochain redmarrage de votre ordinateur...")
			Else
				RegDelete("HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows\CurrentVersion\Run","Wbidou")
			EndIf		
		EndIf
		
		If $msg = $choixfilm Then $duree=ChoixFilm()
		If $msg = $extraire Then ExtraireFilm()
		
		If $msg = $tab AND GUICtrlRead($tab)=3 Then 
			GetCDinfo()
			$timercd=TimerInit( )
			GetCDstatus()
		EndIf
		If GUICtrlRead($tab)=3 AND $timercd AND TimerDiff($timercd)>10000 Then
			GetCDstatus()
			$timercd=TimerInit( )
		EndIf
		If GUICtrlRead($tab)<>3 Then $timercd=0
		If GUICtrlRead($tab)=3 AND BitAND(GUICtrlGetState($compilcd),$GUI_ENABLE) AND GUICtrlRead($compilcd) AND BitAND(GUICtrlGetState($extrairecd),$GUI_DISABLE) Then GUICtrlSetState($extrairecd,$GUI_ENABLE)
		If GUICtrlRead($tab)=3 AND NOT GUICtrlRead($compilcd) AND BitAND(GUICtrlGetState($extrairecd),$GUI_ENABLE) Then GUICtrlSetState($extrairecd,$GUI_DISABLE)		
		If $msg = $extrairecd Then ExtraireCD(GUICtrlRead($compilcd))
			
		If $msg = $GUI_EVENT_CLOSE Then ExitLoop
		
			
	WEnd
	GUIDelete()
EndFunc

; ---------------------- Bloc de fonctions pour l'extraction de CDs audio ----------------------------------

Func ExtraireCD($compil)
	GUISetCursor(15,1)
	GUICtrlSetData($etatcd,"")
	GUICtrlSetState($etatcd,$GUI_SHOW)
	GUICtrlSetData($progresscd,0)
	GUICtrlSetState($progresscd,$GUI_SHOW)
	
	$ffmpeg=GetFFmpeg2Theora()
	If Not $ffmpeg Then
		MsgBox(16,"Erreur","Impossible de localiser la librairie FFmpeg2theora !")
		return 0
	EndIf
	$cdda=GetCDRtools()
	If Not $cdda Then
		MsgBox(16,"Erreur","Impossible de localiser la librairie CDRtools !")
		return 0
	EndIf
	
	$dev=GetCDdev()
	If Not $dev Then return
	
	$dossier=@ScriptDir & "\" & $compil
	If FileExists($dossier) Then
		If StringInStr(FileGetAttrib($dossier), "D") AND MsgBox(33,"Attention","Cette compilation existe dj; y ajouter ces chapitres ?")=2 Then return
	Else
		GUICtrlSetData ($liste,$compil)
		DirCreate($dossier)
	EndIf
	
	GUICtrlSetData($extrairecd,"Interrompre")
	Dim $i
	For $i = 1 to Ubound($pistescd)
		GUICtrlSetData($etatcd,"Copie "&$i&"/"&Ubound($pistescd))
		FileDelete(@ScriptDir &"\audio.wav")
		$cdrpid=Run($cdda&" -D "&$dev&" -H -t "&$i&" -gui",@Scriptdir,@SW_HIDE)
		Sleep(10000)
		If Not FileExists(@ScriptDir &"\audio.wav") Then
			GUICtrlSetData($etatcd,"Erreur !")
			ExitLoop
		EndIf
		While ProcessExists($cdrpid)
			If GUIGetMsg() = $extrairecd Then 
				ProcessClose($cdrpid)
				ExitLoop 2
			EndIf
		Wend 
		GUICtrlSetData($progresscd,(2*$i-1)/(Ubound($pistescd)*2)*100)
		GUICtrlSetData($etatcd,"Conversion "&$i&"/"&Ubound($pistescd))
		RunWait($ffmpeg&' --no-skeleton --novideo -o "'&@ScriptDir &"\"&$compil&"\"&StringFormat("%02d",$i)&"-"&$compil&".ogg"&'" "'&@ScriptDir &"\audio.wav"&'"',@Scriptdir,@SW_HIDE)
		GUICtrlSetData($progresscd,(2*$i)/(Ubound($pistescd)*2)*100)
	Next
	FileDelete(@ScriptDir &"\audio.wav")
	
	GUICtrlSetData($extrairecd,"Extraire !")
	If $i = Ubound($pistescd)+1 Then GUICtrlSetData($etatcd,"Termin !")
	GUICtrlSetData($progresscd,0)
	GUICtrlSetState($progresscd,$GUI_HIDE)
	GUISetCursor(2)
EndFunc


Func GetCDstatus()
	$dev=GetCDdev()
	If Not $dev Then return
	
	$cdda=GetCDRtools()
	If Not $cdda Then
		MsgBox(16,"Erreur","Impossible de localiser la librairie CDRtools !")
		return 0
	EndIf
	
	$cdrpid=Run($cdda&" -D "&$dev&" -J -H -gui -v toc",@Scriptdir,@SW_HIDE,$STDERR_CHILD)
	$debut=TimerInit()
	While ProcessExists($cdrpid)
		if GUIGetMsg() = $tab OR TimerDiff($debut)>10000 Then 
		ProcessClose($cdrpid)
		ExitLoop
		EndIf
	Wend
	$infos=""
	While 1
		$infos&=StderrRead($cdrpid)
		If @error Then ExitLoop			    
	Wend
	StdioClose($cdrpid)
	If StringRegExp ( $infos, "load cdrom please" ,0) OR NOT $infos Then
		GUICtrlSetData ($statuscd,"Aucun disque dtect...")
		GUICtrlSetState($compilcd,$GUI_DISABLE)
		GUICtrlSetState($extrairecd,$GUI_DISABLE)
		return 0
	EndIf
	$pistescd=StringRegExp ( $infos, "(T\d{2}):(?: *\d* *)(\d*):(\d*)(?:.*)audio",4)
	If Ubound($pistescd)=0 Then
		GUICtrlSetData ($statuscd,"Le CD insr n'est pas audio !")
		GUICtrlSetState($compilcd,$GUI_DISABLE)
		GUICtrlSetState($extrairecd,$GUI_DISABLE)
		return 0
	EndIf
	Dim $i,$a,$dureecd
	For $i=1 to Ubound($pistescd)
		$a=$pistescd[$i-1]
		$dureecd+=$a[2]*60 + $a[3]
	Next
	GUICtrlSetData ($statuscd,"Prt  copier: "&Ubound($pistescd)&" pistes ("&Temps($dureecd)&")")
	GUICtrlSetState($compilcd,$GUI_ENABLE)
	return 1
EndFunc


Func GetCDdev()
	$cdr=GUICtrlRead($selcd)
	Dim $i,$a
	For $i=1 to Ubound($cdroms)
		$a=$cdroms[$i-1]
		If ($a[2]&" "&$a[3])=$cdr Then return $a[1]
	Next
EndFunc


Func GetCDinfo()
	Sablier(1)
	$cdda=GetCDRtools()
	If Not $cdda Then
		MsgBox(16,"Erreur","Impossible de localiser la librairie CDRtools !")
		return 0
	EndIf
	
	$cdrpid=Run($cdda&" -scanbus",@Scriptdir,@SW_HIDE,$STDERR_CHILD)
	If Not ProcessWaitClose($cdrpid,30) Then ProcessClose($cdrpid)
	$infos=""
	While 1
		$infos&=StderrRead($cdrpid)
		If @error Then ExitLoop			    
	Wend
	StdioClose($cdrpid)
	$cdroms=StringRegExp ( $infos, "\t(\d,\d,\d)(?:.*[)] ')(.[^']*)(?:' ')(.[^']*)(?:' .[^']*' )(?:Removable CD-ROM)" ,4)
	Dim $i,$a,$cdrlist
	If Ubound($cdroms)>0 Then
		For $i=1 to Ubound($cdroms)
			$a=$cdroms[$i-1]
			$cdrlist&=$a[2]&" "&$a[3]&"|"			
		Next
		GUICtrlSetData($selcd, $cdrlist,$a[2]&" "&$a[3])
		If Ubound($cdroms)=1 Then GUICtrlSetState($selcd,$GUI_DISABLE)
	EndIf	
	Sablier(0)
EndFunc


Func GetCDRtools () ; vrifie si la lib est installe, sinon l'installe, et renvoie son path ou erreur
	If FileExists(@ScriptDir & "\cdda2wav.exe") AND FileExists(@ScriptDir & "\cygwin1.dll") Then return @ScriptDir & "\cdda2wav.exe"
	If Not @compiled Then Return 0
	
	$wini=GuiCreate("Dcompression en cours...", 300, 130,-1,-1,$WS_EX_OVERLAPPEDWINDOW)
	GUISetFont ("9" , 400)
	GuiCtrlCreateLabel("Installation de CDRtools en cours..."&@CRLF&@CRLF&"Merci de patienter !", 20, 30)
	GuiSetState(@SW_SHOW,$wini)
	$i1=FileInstall("cdda2wav.exe",@ScriptDir &"\cdda2wav.exe",1)
	$i2=FileInstall("cygwin1.dll",@ScriptDir &"\cygwin1.dll",1)
	$i3=FileInstall("Licence CDDA2WAV CDDL-Schily.txt",@ScriptDir &"\Licence CDDA2WAV CDDL-Schily.txt",1)	
	GUIDelete($wini)
	
	If $i1 AND $i2 AND $i3 Then return @ScriptDir & "\cdda2wav.exe"
	return 0
EndFunc


; ---------------------- Bloc de fonctions pour l'extraction audio d'une vido ----------------------------------


Func GetFFmpeg2Theora () ; vrifie si la lib est installe, sinon l'installe, et renvoie son path ou erreur
	If FileExists(@ScriptDir & "\ffmpeg2theora-0.23.exe") Then return @ScriptDir & "\ffmpeg2theora-0.23.exe"
	If Not @compiled Then Return 0
	
	$wini=GuiCreate("Dcompression en cours...", 300, 130,-1,-1,$WS_EX_OVERLAPPEDWINDOW)
	GUISetFont ("9" , 400)
	GuiCtrlCreateLabel("Installation de FFmpeg2Theora en cours..."&@CRLF&@CRLF&"Merci de patienter !", 20, 30)
	GuiSetState(@SW_SHOW,$wini)
	$i1=FileInstall("ffmpeg2theora-0.23.exe",@ScriptDir &"\ffmpeg2theora-0.23.exe",1)
	$i2=FileInstall("Licence FFMPEG2THEORA GPL2.txt",@ScriptDir &"\Licence FFMPEG2THEORA GPL2.txt",1)	
	GUIDelete($wini)
	
	If $i1 AND $i2 Then return @ScriptDir & "\ffmpeg2theora-0.23.exe"
	return 0
EndFunc	


Func ExtraireFilm ()
$sup=GUICtrlRead($dureesupp)
If $sup>$duree Then $sup=0
If $sup="" Then $sup=0
$chap=GUICtrlRead($dureechap)
If ($chap*60)>$duree Then $chap=0
If $chap=1 Then $chap=0

$ffmpeg=GetFFmpeg2Theora()
If Not $ffmpeg Then
	MsgBox(16,"Erreur","Impossible de localiser la librairie FFmpeg2theora !")
	return 0
EndIf

Dim $szDrive, $szDir, $szFName, $szExt
_PathSplit($fichierfilm, $szDrive, $szDir, $szFName, $szExt)

If GUICtrlRead($compil)="" Then GUICtrlSetData($compil,$szFName)

$dossier=@ScriptDir & "\" & GUICtrlRead($compil)
If FileExists($dossier) Then
	If StringInStr(FileGetAttrib($dossier), "D") AND MsgBox(33,"Attention","Cette compilation existe dj; y ajouter ces chapitres ?")=2 Then return
Else
	GUICtrlSetData ($liste,GUICtrlRead($compil))
	DirCreate($dossier)
EndIf
	
Sablier(1)
GUICtrlSetState($extraire,$GUI_DISABLE)
GUICtrlSetData($etatfilm,"")
GUICtrlSetState($etatfilm,$GUI_SHOW)
GUICtrlSetData($progressfilm,0)
GUICtrlSetState($progressfilm,$GUI_SHOW)

; 1ere passe: conversion en ogg
$taille=FileGetSize($fichierfilm)
$dest=Test($chap OR $sup, @ScriptDir & '\' & $szFName &'.ogg', $dossier & '\' & $szFName &'.ogg')
$ffpid=Run($ffmpeg&' --no-skeleton --novideo -c 1 -o "' & $dest &'" "'& $fichierfilm &'"', @ScriptDir , @SW_HIDE, $STDERR_CHILD )	
while ProcessExists($ffpid)				
	$stats=ProcessGetStats($ffpid,1)
	$p=$stats[3]/$taille*100
	if $p > 100 Then $p=100
	GUICtrlSetData($progressfilm,$p)
	GUICtrlSetData($etatfilm,"Conversion: "&Int($p) & " %")				
	Sleep(1000)
Wend	

; 2e passe, s'il y a des chapitres: dcoupage !
If $chap OR $sup Then
	$parties=Test($chap,Ceiling(($duree-$sup)/($chap*60)),1)
	For $i = 1 to $parties
		RunWait($ffmpeg&' --no-skeleton --novideo -o "' & $dossier & '\' & Test($parties>1,StringFormat("%02d",$i)&"-","")&$szFName &'.ogg" -s ' & int($sup+($i-1)*$chap*60) & ' ' & Test($parties>1,'-e '& int($sup+$i*$chap*60) &' ',"") &'"'& $dest &'"',@ScriptDir , @SW_HIDE)	
		GUICtrlSetData($progressfilm,$i/$parties*100)
		GUICtrlSetData($etatfilm,"dcoupage: "&Int($i/$parties*100) & " %")
	Next
	FileDelete($dest)
EndIf

If $chap Then
	If $bidou AND IniRead ($bidou&"\baby_config.txt", "Random", "Random", "no" )="yes" Then 
		If 6 = MsgBox(36,"Attention",'Le mode "lecture en ordre alatoire" est actuellement activ sur votre BabyBidou; ' & @CRLF & "Ce mode n'est pas conseill avec la lecture d'une bande son chapitre ! " & @CRLF & "(sauf si vous voulez couter les chapitres dans un ordre bizarre...)" & @CRLF & "" & @CRLF & "Souhaitez vous dsactiver immdiatement le mode aatoire ?") Then 
			IniWrite ($bidou&"\baby_config.txt", "Random", "Random", "no")
			GUICtrlSetState($aleat,$GUI_UNCHECKED)
		EndIf
	ElseIf NOT $bidou Then 
		MsgBox(64,"Attention",'Ne pas activer le mode "Lecture alatoire" pour lire une bande son chapitre...' & @CRLF & "(sauf si vous voulez couter les chapitres dans un ordre bizarre...)")
	EndIf
EndIf

GUICtrlSetState($progressfilm,$GUI_HIDE)
GUICtrlSetData($etatfilm,"Termin !")	
GUICtrlSetState($extraire,$GUI_ENABLE)
Sablier(0)
EndFunc


Func ChoixFilm ()
	GUICtrlSetData($film,"")
	GUICtrlSetData($compil,"")
	GUICtrlSetData($dureesupp,"")
	GUICtrlSetState($compil,$GUI_DISABLE)
	GUICtrlSetState($dureesupp,$GUI_DISABLE)
	GUICtrlSetState($dureechap,$GUI_DISABLE)
	GUICtrlSetState($extraire,$GUI_DISABLE)
	GUICtrlSetState($etatfilm,$GUI_HIDE)
	
	$ffmpeg=GetFFmpeg2Theora()
	If Not $ffmpeg Then
		MsgBox(16,"Erreur","Impossible de localiser la librairie FFmpeg2theora !")
		return 0
	EndIf
	
	$fichierfilm=FileOpenDialog("Emplacement du fichier vido ?", @ScriptDir, "Vido (*.avi;*.mp*;*.og*;*.mov;*.wmv;*.mkv;*.divx)|Tous documents (*.*)", 2 )
	If Not $fichierfilm OR Not FileExists($fichierfilm) Then return 0
	Dim $szDrive, $szDir, $szFName, $szExt
	_PathSplit($fichierfilm, $szDrive, $szDir, $szFName, $szExt)	
	GUISetCursor(15,1)
	$ffpid=Run($ffmpeg&" --novideo --noaudio "&'"'& $fichierfilm &'"',@ScriptDir , @SW_HIDE, $STDERR_CHILD )	
	while ProcessExists($ffpid)		
	Wend
	FileDelete($szDrive&$szDir&$szFName&".ogv")
	$infos=""
	While 1
		$infos&=StderrRead($ffpid)
		If @error Then ExitLoop			    
	Wend	
	GUISetCursor(2)
	
	$array = StringRegExp($infos, 'Duration: ([0-9]{2}):([0-9]{2}):([0-9]{2})', 1)
	If StringRegExp($infos, 'Unable to decode input.',0) OR StringRegExp($infos, 'unknown data format.',0) OR UBound($array)=0 Then
		GUICtrlSetData($film,"Fichier invalide...")
		return 0
	EndIf
	
	GUICtrlSetData($compil,$szFName)
	GUICtrlSetState($compil,$GUI_ENABLE)
	GUICtrlSetState($dureesupp,$GUI_ENABLE)
	GUICtrlSetState($dureechap,$GUI_ENABLE)
	GUICtrlSetState($extraire,$GUI_ENABLE)
	GUICtrlSetData($film,$szFName&$szExt&" ("&Test($array[0]>0,int($array[0])&"h ","")&Test($array[1]>0,int($array[1])&"m ","")&int($array[2]+1)&"s)")	
	GUICtrlSetTip($film,$fichierfilm)
	return int($array[0])*3600+int($array[1])*60+int($array[2])+1
EndFunc


; ---------------------- Bloc de fonctions spcifiques au BabyBidou ----------------------------------


Func Bidou()
	$drive=0
	$var = DriveGetDrive( "REMOVABLE" )
	If NOT @error Then
		For $i = 1 to $var[0]
			If $var[$i]<>"a:" AND $var[$i]<>"b:" AND DriveStatus($var[$i])="READY" AND FileExists($var[$i]&"\baby_config.txt") Then return $var[$i]
		Next
	EndIf
	return 0
EndFunc


Func TestBiDou()
	$drive=Bidou()

	If Not $drive OR _GUICtrlListBox_GetSelCount($liste)=0 Then 
		If BitAND(GUICtrlGetState($transfert),$GUI_ENABLE) Then GUICtrlSetState($transfert,$GUI_DISABLE)
	ElseIf BitAND(GUICtrlGetState($transfert),$GUI_DISABLE) Then
		GUICtrlSetState($transfert,$GUI_ENABLE)
	EndIf

	If ($drive) Then 
		AllowConfig($GUI_ENABLE)
		If BitAND(GUICtrlGetState($noconn),$GUI_SHOW) Then GUICtrlSetState ($noconn,$GUI_HIDE)
	Else
		AllowConfig($GUI_DISABLE)
		If BitAND(GUICtrlGetState($noconn),$GUI_HIDE) Then GUICtrlSetState ($noconn,$GUI_SHOW)
	EndIf
	
	return $drive
EndFunc


Func GetConfig()
GUICtrlSetData($volumemax,IniRead ($bidou&"\baby_config.txt", "Speaker", "MaxSpeakerPower", "7" ))
GUICtrlSetData($volumeini,IniRead ($bidou&"\baby_config.txt", "Speaker", "InitSpeakerPower", "5" ))
GUICtrlSetState($fade,Test(IniRead ($bidou&"\baby_config.txt", "Fading", "FadeEnable", "yes" )="yes",$GUI_CHECKED,$GUI_UNCHECKED))
GUICtrlSetData($fadeduree,IniRead ($bidou&"\baby_config.txt", "Fading", "FadingDuration", "5" ))
GUICtrlSetState($aleat,Test(IniRead ($bidou&"\baby_config.txt", "Random", "Random", "no" )="yes",$GUI_CHECKED,$GUI_UNCHECKED))
GUICtrlSetState($repet,Test(IniRead ($bidou&"\baby_config.txt", "Repeat", "Repeat", "no" )="yes",$GUI_CHECKED,$GUI_UNCHECKED))
GUICtrlSetState($egaliseur,Test(IniRead ($bidou&"\baby_config.txt", "Audio", "AudioEffect", "yes" )="yes",$GUI_CHECKED,$GUI_UNCHECKED))
GUICtrlSetState($reveil,Test(IniRead ($bidou&"\baby_config.txt", "Wakeup", "VoiceAutoDetect", "no" )="yes",$GUI_CHECKED,$GUI_UNCHECKED))
GUICtrlSetData($volumereveil,IniRead ($bidou&"\baby_config.txt", "Wakeup", "WakeupSpeakerPower", "3" ))
GUICtrlSetData($sensreveil,IniRead ($bidou&"\baby_config.txt", "Wakeup", "VoiceLevel", "5" ))
GUICtrlSetData($reveilduree,IniRead ($bidou&"\baby_config.txt", "Wakeup", "VoiceDuration", "10" ))
GUICtrlSetState($record,Test(IniRead ($bidou&"\baby_config.txt", "Record", "RecordEnable", "yes" )="yes",$GUI_CHECKED,$GUI_UNCHECKED))
GUICtrlSetState($records,Test(IniRead ($bidou&"\baby_config.txt", "Record", "RecordWarning", "yes" )="yes",$GUI_CHECKED,$GUI_UNCHECKED))
EndFunc


Func AllowConfig($status)
If $status=$GUI_ENABLE AND BitAND(GUICtrlGetState($volumemax),$GUI_ENABLE) Then return
If $status=$GUI_DISABLE AND BitAND(GUICtrlGetState($volumemax),$GUI_DISABLE) Then return
If $status=$GUI_ENABLE Then GetConfig()
GUICtrlSetState($volumemax,$status)
GUICtrlSetState($volumeini,$status)
GUICtrlSetState($fade,$status)
GUICtrlSetState($fadeduree,$status)
GUICtrlSetState($aleat,$status)
GUICtrlSetState($repet,$status)
GUICtrlSetState($egaliseur,$status)
GUICtrlSetState($reveil,$status)
GUICtrlSetState($volumereveil,$status)
GUICtrlSetState($sensreveil,$status)
GUICtrlSetState($reveilduree,$status)
GUICtrlSetState($record,$status)
GUICtrlSetState($records,$status)
EndFunc


Func Transferer ()
	GUISetCursor(15,1)
	$aItems=_GUICtrlListBox_GetSelItemsText($liste)
	Dim $fichiers[1]
	For $i = 1 To $aItems[0]
		$search = FileFindFirstFile(@ScriptDir&"\"&$aItems[$i]&"\*.mp3")  
		If $search Then
			While 1
				$file = FileFindNextFile($search) 
				If @error Then ExitLoop
				_ArrayAdd($fichiers, @ScriptDir&"\"&$aItems[$i]&"\"&$file)
			WEnd
		FileClose($search)
		EndIf
		$search = FileFindFirstFile(@ScriptDir&"\"&$aItems[$i]&"\*.aac")  
		If $search Then
			While 1
				$file = FileFindNextFile($search) 
				If @error Then ExitLoop
				_ArrayAdd($fichiers, @ScriptDir&"\"&$aItems[$i]&"\"&$file)
			WEnd
		FileClose($search)
		EndIf
		$search = FileFindFirstFile(@ScriptDir&"\"&$aItems[$i]&"\*.ogg")  
		If $search Then
			While 1
				$file = FileFindNextFile($search) 
				If @error Then ExitLoop
				_ArrayAdd($fichiers, @ScriptDir&"\"&$aItems[$i]&"\"&$file)
			WEnd
		FileClose($search)
		EndIf
		$search = FileFindFirstFile(@ScriptDir&"\"&$aItems[$i]&"\*.oga")  
		If $search Then
			While 1
				$file = FileFindNextFile($search) 
				If @error Then ExitLoop
				_ArrayAdd($fichiers, @ScriptDir&"\"&$aItems[$i]&"\"&$file)
			WEnd
		FileClose($search)
		EndIf
		$search = FileFindFirstFile(@ScriptDir&"\"&$aItems[$i]&"\*.wma")  
		If $search Then
			While 1
				$file = FileFindNextFile($search) 
				If @error Then ExitLoop
				_ArrayAdd($fichiers, @ScriptDir&"\"&$aItems[$i]&"\"&$file)
			WEnd
		FileClose($search)
		EndIf
		$search = FileFindFirstFile(@ScriptDir&"\"&$aItems[$i]&"\*.wav")  
		If $search Then
			While 1
				$file = FileFindNextFile($search) 
				If @error Then ExitLoop
				_ArrayAdd($fichiers, @ScriptDir&"\"&$aItems[$i]&"\"&$file)
			WEnd
		FileClose($search)
		EndIf
	Next		
	_ArrayDelete($fichiers, 0)
	If (GUICtrlRead($effacer)=$GUI_CHECKED) Then
		FileDelete ( $bidou&"\*.mp3" )
		FileDelete ( $bidou&"\*.wav" )
		FileDelete ( $bidou&"\*.ogg" )
		FileDelete ( $bidou&"\*.oga" )
		FileDelete ( $bidou&"\*.aac" )
		FileDelete ( $bidou&"\*.wma" )
	EndIf
	GUICtrlSetState($etat,$GUI_SHOW)
	GUICtrlSetState($progress,$GUI_SHOW)
	GUICtrlSetState($transfert,$GUI_DISABLE)
	GUISetState(@SW_DISABLE,$win)
	For $i=0 To UBound($fichiers)-1
		$p=$i/UBound($fichiers)*100
		GUICtrlSetData($etat,Int($p) & " %")
		GUICtrlSetData($progress,$i/UBound($fichiers)*100)
		FileCopy($fichiers[$i],$bidou,1)
	Next
	GUICtrlSetState($progress,$GUI_HIDE)
	GUICtrlSetData($etat,"Termin !")
	GUISetState(@SW_ENABLE,$win)
	$aItems = _GUICtrlListBox_GetSelItems($liste)
	For $i = 1 To $aItems[0]
		_GUICtrlListBox_SetSel($liste,$aItems[$i],0)
	Next
	If (GUICtrlRead($ejection)=$GUI_CHECKED) Then _EjectDrive(StringLeft($bidou,1))
	GUISetCursor(2)
EndFunc


; ---------------------- Bloc de fonctions diverses ----------------------------------


Func Temps($s)
If $s<60 Then 
	return(Int($s)&"s")
ElseIf $s<3600 Then
	return(Int($s/60)&"m "&Int(Mod($s,60))&"s")
Else
	return(Int($s/3600)&"h "&Int(Mod($s,3600)/60)&"m "&Int(Mod($s,60))&"s")
EndIf
EndFunc


Func Test($test,$yes,$no)
If $test Then return $yes
return $no
EndFunc


Func Licence()
If FileGetSize(@ScriptDir &"\Licence_CeCILL_V2-fr.txt")<>21979 Then FileInstall("Licence_CeCILL_V2-fr.txt", @ScriptDir &"\Licence_CeCILL_V2-fr.txt",1)
$win0=GuiCreate("Contrat de Licence Wbidou", 500, 420,-1,-1,$WS_EX_OVERLAPPEDWINDOW)
GUISetFont ("8" , 400)
GuiCtrlCreateLabel($Apropos, 20, 10,460,150)
GUICtrlCreateEdit(FileRead(@ScriptDir &"\Licence_CeCILL_V2-fr.txt"),10,170,480,170,BitOr($ES_MULTILINE,$ES_READONLY,$WS_VSCROLL))
GUISetFont ("9" , 400)
$ok=GUICtrlCreateButton ( " Accepter ", 60, 355,80)
$nok=GUICtrlCreateButton ( " Refuser ", 210, 355,80)
$cecill=GUICtrlCreateButton ( " Cecill ? ", 360, 355,80)
GUICtrlSetTip(-1,"http://www.cecill.info")
GuiSetState(@SW_SHOW,$win0)
While 1
	$msg=GuiGetMsg()
	If $msg=$cecill Then ShellExecute("http://www.cecill.info")
	If $msg=$ok Then
		GUIDelete($win0)
		return 1
	EndIf
	If $msg=$nok Then
		GUIDelete($win0)
		return 0
	EndIf
Wend
EndFunc


Func Sablier($etat)
If $etat Then
	GUISetCursor(15,1)
	GUISetState(@SW_DISABLE,$win)
Else	
	GUISetState(@SW_ENABLE,$win)
	GUISetCursor(2)
EndIf
EndFunc


Func SetupEject()
	#include <WinAPI.au3>
	; http://www.autoitscript.com/forum/index.php?showtopic=83470
	; Constants
	Global Const $FS_READ = 0x1
	Global Const $FS_WRITE = 0x2
	Global Const $O_EXISTS = 3
	Global Const $INVALID_HANDLE_VALUE = Ptr(0xFFFFFFFF); invalid ptr value
	Global Const $IOCTL_STORAGE_GET_DEVICE_NUMBER = 0x2D1080
	Global Const $DRIVE_REMOVABLE = 2
	Global Const $DRIVE_FIXED = 3
	Global Const $DRIVE_CDROM = 5
	Global Const $DIGCF_PRESENT = 0x2
	Global Const $DIGCF_DEVICEINTERFACE = 0x10
	Global Const $NULL = Chr(0)
	Global Const $CR_SUCCESS = 0x0
	Global Const $DN_REMOVABLE = 0x4000
	Global Const $CM_REMOVE_NO_RESTART = 0x2
	Global Const $CR_ACCESS_DENIED = 0x33
	Global Const $PNP_VetoTypeUnknown = 0         ; Name is unspecified
	Global Const $PNP_VetoLegacyDevice = 1        ; Name is an Instance Path
	Global Const $PNP_VetoPendingClose = 2        ; Name is an Instance Path
	Global Const $PNP_VetoWindowsApp = 3        ; Name is a Module
	Global Const $PNP_VetoWindowsService = 4    ; Name is a Service
	Global Const $PNP_VetoOutstandingOpen = 5    ; Name is an Instance Path
	Global Const $PNP_VetoDevice = 6            ; Name is an Instance Path
	Global Const $PNP_VetoDriver = 7            ; Name is a Driver Service Name
	Global Const $PNP_VetoIllegalDeviceRequest = 8; Name is an Instance Path
	Global Const $PNP_VetoInsufficientPower = 9    ; Name is unspecified
	Global Const $PNP_VetoNonDisableable = 10    ; Name is an Instance Path
	Global Const $PNP_VetoLegacyDriver = 11        ; Name is a Service
	Global Const $PNP_VetoInsufficientRights = 12; Name is unspecified

	; Structures
	Global Const $STORAGE_DEVICE_NUMBER = "ulong DeviceType;ulong DeviceNumber;ulong PartitionNumber"
	Global Const $SP_DEV_BUF = "byte[1024]"
	Global Const $SP_DEVICE_INTERFACE_DETAIL_DATA = "dword cbSize;char DevicePath[1020]"; created at SP_DEV_BUF ptr
	Global Const $SP_DEVICE_INTERFACE_DATA = "dword cbSize;byte InterfaceClassGuid[16];dword Flags;ptr Reserved"; GUID struct = 16 bytes
	Global Const $SP_DEVINFO_DATA = "dword cbSize;byte ClassGuid[16];dword DevInst;ptr Reserved"
EndFunc


Func _EjectDrive($drive)
; "X:\"    -> for GetDriveType
    $szRootPath = $drive & ":\"
; "X:"     -> for QueryDosDevice
    $szDevicePath = $drive & ":"
; "\\.\X:" -> to open the volume
    $szVolumeAccessPath = "\\.\" & $drive & ":"

    $DeviceNumber = -1

    $hVolume = DllCall("kernel32.dll", "ptr", "CreateFile", "str", $szVolumeAccessPath, "dword", 0, _
                        "dword", BitOR($FS_READ, $FS_WRITE), "ptr", $NULL, "dword", $O_EXISTS, _
                        "dword", 0, "ptr", $NULL)
    $hVolume = $hVolume[0]
    If $hVolume == $INVALID_HANDLE_VALUE Then Return 1

    $sdn = DllStructCreate($STORAGE_DEVICE_NUMBER)
    $res = DllCall("kernel32.dll", "int", "DeviceIoControl", "ptr", $hVolume,"dword", $IOCTL_STORAGE_GET_DEVICE_NUMBER, _
                    "ptr", $NULL, "dword", 0, "ptr", DllStructGetPtr($sdn), "dword", DllStructGetSize($sdn), _
                    "dword*", "", "ptr", $NULL)
    If $res[0] Then $DeviceNumber = DllStructGetData($sdn, "DeviceNumber")
    
    $res = DllCall("kernel32.dll", "int", "CloseHandle", "ptr", $hVolume)
    If Not $res[0] Then Return 1

    If $DeviceNumber == -1 Then Return 1

    $DriveType = DllCall("kernel32.dll", "uint", "GetDriveType", "str", $szRootPath)
    $DriveType = $DriveType[0]

; get the dos device name (like \device\floppy0)
; to decide if it's a floppy or not
    $res = DllCall("kernel32.dll", "dword", "QueryDosDevice", "str", $szDevicePath, "str", "", "dword", 260)
    If Not $res[0] Then Return 1
    $szDosDeviceName = $res[2]

    $DevInst = _GetDrivesDevInstByDeviceNumber($DeviceNumber, $DriveType, $szDosDeviceName)
    If $DevInst == 0 Then Return 1
    
    Return _DevInstEject($DevInst)
EndFunc

Func _GetDrivesDevInstByDeviceNumber($DeviceNumber, $DriveType, $szDosDeviceName)
	; GUIDs
	; GUID_DEVINTERFACE_DISK =         0x53f56307L, 0xb6bf, 0x11d0, 0x94, 0xf2, 0x00, 0xa0, 0xc9, 0x1e, 0xfb, 0x8b
	; GUID_DEVINTERFACE_CDROM =     0x53f56308L, 0xb6bf, 0x11d0, 0x94, 0xf2, 0x00, 0xa0, 0xc9, 0x1e, 0xfb, 0x8b
	; GUID_DEVINTERFACE_FLOPPY =     0x53f56311L, 0xb6bf, 0x11d0, 0x94, 0xf2, 0x00, 0xa0, 0xc9, 0x1e, 0xfb, 0x8b
	$guidDisk = DllStructCreate($tagGUID)
	DllStructSetData($guidDisk, "Data1", 0x53f56307)
	DllStructSetData($guidDisk, "Data2", 0xb6bf)
	DllStructSetData($guidDisk, "Data3", 0x11d0)
	DllStructSetData($guidDisk, "Data4", Binary("0x94f200a0c91efb8b"))
	$guidCDROM = DllStructCreate($tagGUID)
	DllStructSetData($guidCDROM, "Data1", 0x53f56308)
	DllStructSetData($guidCDROM, "Data2", 0xb6bf)
	DllStructSetData($guidCDROM, "Data3", 0x11d0)
	DllStructSetData($guidCDROM, "Data4", Binary("0x94f200a0c91efb8b"))
	$guidFloppy = DllStructCreate($tagGUID)
	DllStructSetData($guidFloppy, "Data1", 0x53f56311)
	DllStructSetData($guidFloppy, "Data2", 0xb6bf)
	DllStructSetData($guidFloppy, "Data3", 0x11d0)
	DllStructSetData($guidFloppy, "Data4", Binary("0x94f200a0c91efb8b"))
	
    $IsFloppy = (StringInStr($szDosDeviceName, "\floppy") <> 0)
    
    Local $GUID
    Switch $DriveType
        Case $DRIVE_REMOVABLE
            If $IsFloppy Then
                $GUID = DllStructGetPtr($guidFloppy)
            Else
                $GUID = DllStructGetPtr($guidDisk)
            EndIf
        Case $DRIVE_FIXED
            $GUID = DllStructGetPtr($guidDisk)
        Case $DRIVE_CDROM
            $GUID = DllStructGetPtr($guidCDROM)
        Case Default
            Return 0
    EndSwitch
    
; Get device interface info set handle
  ; for all devices attached to system
    $hDevInfo = DllCall("setupapi.dll", "ptr", "SetupDiGetClassDevs", "ptr", $GUID, "ptr", $NULL, "hwnd", $NULL, _
                        "dword", BitOR($DIGCF_PRESENT, $DIGCF_DEVICEINTERFACE))
    $hDevInfo = $hDevInfo[0]
    If $hDevInfo == $INVALID_HANDLE_VALUE Then Return 0
    
; Retrieve a context structure for a device interface
; of a device information set.
    $dwIndex = 0
    $bRet = False

    $buf = DllStructCreate($SP_DEV_BUF)
    $pspdidd = DllStructCreate($SP_DEVICE_INTERFACE_DETAIL_DATA, DllStructGetPtr($buf))
    $spdid = DllStructCreate($SP_DEVICE_INTERFACE_DATA)
    $spdd = DllStructCreate($SP_DEVINFO_DATA)
    
    DllStructSetData($spdid, "cbSize", DllStructGetSize($spdid))

    While True
        $bRet = DllCall("setupapi.dll", "int", "SetupDiEnumDeviceInterfaces", "ptr", $hDevInfo, "ptr", $NULL, _
                        "ptr", $GUID, "dword", $dwIndex, "ptr", DllStructGetPtr($spdid))
        If Not $bRet[0] Then ExitLoop

        $res = DllCall("setupapi.dll", "int", "SetupDiGetDeviceInterfaceDetail", "ptr", $hDevInfo, "ptr", DllStructGetPtr($spdid), _
                        "ptr", $NULL, "dword", 0, "dword*", "", "ptr", $NULL)
        $dwSize = $res[5]
        
        If $dwSize <> 0 And $dwSize <= DllStructGetSize($buf) Then
            DllStructSetData($pspdidd, "cbSize", 5); sizeof dword + char = 5 bytes
            _ZeroMemory(DllStructGetPtr($spdd), DllStructGetSize($spdd))
            DllStructSetData($spdd, "cbSize", DllStructGetSize($spdd))

            $res = DllCall("setupapi.dll", "int", "SetupDiGetDeviceInterfaceDetail", "ptr", $hDevInfo, "ptr", DllStructGetPtr($spdid), _
                            "ptr", DllStructGetPtr($pspdidd), "dword", $dwSize, "dword*", "", "ptr", DllStructGetPtr($spdd))
                            
            If $res[0] Then
                
                $hDrive = DllCall("kernel32.dll", "ptr", "CreateFile", "str", DllStructGetData($pspdidd, "DevicePath"), "dword", 0, _
                                    "dword", BitOR($FS_READ, $FS_WRITE), "ptr", $NULL, "dword", $O_EXISTS, _
                                    "dword", 0, "ptr", $NULL)
                $hDrive = $hDrive[0]
                          
                If $hDrive <> $INVALID_HANDLE_VALUE Then
                    $sdn2 = DllStructCreate($STORAGE_DEVICE_NUMBER)
                    $res = DllCall("kernel32.dll", "int", "DeviceIoControl", "ptr", $hDrive, "dword", $IOCTL_STORAGE_GET_DEVICE_NUMBER, _
                            "ptr", $NULL, "dword", 0, "ptr", DllStructGetPtr($sdn2), "dword", DllStructGetSize($sdn2), _
                            "dword*", "", "ptr", $NULL)
                    
                    If $res[0] Then
                        If $DeviceNumber == DllStructGetData($sdn2, "DeviceNumber") Then
                            $res = DllCall("kernel32.dll", "int", "CloseHandle", "ptr", $hDrive)
                            $res = DllCall("setupapi.dll", "int", "SetupDiDestroyDeviceInfoList", "ptr", $hDevInfo)
                            Return DllStructGetData($spdd, "DevInst")
                        EndIf
                    EndIf
                    
                    $res = DllCall("kernel32.dll", "int", "CloseHandle", "ptr", $hDrive)
                EndIf
            EndIf
        EndIf
        $dwIndex += 1
    WEnd

    $res = DllCall("setupapi.dll", "int", "SetupDiDestroyDeviceInfoList", "ptr", $hDevInfo)

    Return 0
EndFunc

Func _DevInstEject($DevInst)
    $bSuccess = False

; get drives's parent, e.g. the USB bridge,
; the SATA port, an IDE channel with two drives, etc.
    $res = DllCall("setupapi.dll", "dword", "CM_Get_Parent", "dword*", "", "dword", $DevInst, "ulong", 0)
    If Not $res[0] == $CR_SUCCESS Then Return 1
    $DevInstParent = $res[1]
    
    $res = DllCall("setupapi.dll", "dword", "CM_Get_Device_IDW", "ptr", $DevInstParent, "wstr", "", "ulong", 1024, "ulong", 0)
    
    $res = DllCall("setupapi.dll", "dword", "CM_Get_DevNode_Status", "ulong*", "", "ulong*", "", "ptr", $DevInstParent, "ulong", 0)
    $IsRemovable = (BitAND($res[1], $DN_REMOVABLE) <> 0)

    For $tries = 1 To 3
; sometimes we need some tries...
        $res = DllCall("setupapi.dll", "dword", "CM_Query_And_Remove_SubTreeW", "dword", $DevInstParent, _
                        "dword*", "", "wstr", "", "ulong", 260, "ulong", $CM_REMOVE_NO_RESTART)
        If $res[0] == $CR_ACCESS_DENIED Then
            $res = DllCall("setupapi.dll", "dword", "CM_Request_Device_EjectW", "dword", $DevInstParent, _
                            "dword*", "", "wstr", "", "ulong", 260, "ulong", 0)
        EndIf

        $bSuccess = (($res[0] == $CR_SUCCESS) And ($res[2] == $PNP_VetoTypeUnknown))
        If $bSuccess Then ExitLoop

        Sleep(500); required to give the next tries a chance
    Next
    
    Return $bSuccess
EndFunc

Func _ZeroMemory($ptr, $size)
    $struct = DllStructCreate("byte[" & $size & "]", $ptr); create a byte struct at ptr of memory to zero
    $szdata = "0x"
    For $i = 1 To $size; create $size byte string of binary 0's
        $szdata &= "00"
    Next
    DllStructSetData($struct, 1, Binary($szdata)); zero the memory
EndFunc
